#!/usr/bin/perl
#==============================================================================




#==============================================================================

use strict;         # request conservative error checking
use warnings;

use File::Spec;

# --------------------- DECLARE VARIABLES ------------------------------

my $DNA;
my $DNAlen;



# get the DNA sequence stored in a Perl string
$DNA = getDNA("test1.fna");

$DNA = uc($DNA);

$DNAlen = length($DNA);

print "We are assuming we are searching the upstream region ";
print "of a certain gene.\n\n";

print "Region ($DNAlen bp) being searched is:\n$DNA \n\n";

print "=================================================================\n";
   




print "=================================================================\n";




# ------- Do NOT change the Perl below this line --------------------------------


#-------------------- Subroutine for you to use -----------------------
#
# This subroutine (sometimes called a function) below is ready for you to
# use in your program. Think of this routine as a "button on your
# calculator" ... this is ready for to use. When you "use" this
# routine, we say "your program is CALLING" for the use of that routine.
#-----------------------------------------------------------------------

#-------\
# getDNA \
#-----------------------------------------------------------------------
# Subroutine to open a FASTA formatted file of DNA sequence, remove
# first (header) line, newline characters, and return as one big string.
#
# A sample of how you might "call" this subroutine from your program
# to 'get' the DNA for chromosome III of the worm, C.elegans.
#
#                  $sequence = getDNA("worm_III.fna");

sub getDNA
{
	my $filename = shift(@_);  # get the filename sent
 
  my $firstline;             # holds header (first) line of file with name, etc
  my $DNAsequence;           # holds the entire sequence of DNA in the file
                             # to return
  my @lines;                 # used to hold ALL the lines from the DNA file
 
  # --------------------------------------------------------------------------
  # MacOS: If you are using TextWrangler, uncomment the next two lines
  #my @path	= File::Spec->splitdir( File::Spec->rel2abs($0) );
  #$filename	= File::Spec->catfile( @path[0 .. $#path - 1], $filename );
  
  my $fh;
  print "\n$filename\n\n";
  
  # open the file of words or motif
  open($fh, '<', $filename) or die $!;
  
  # try to open the file; if no file by that name, print a warning and exit
  #open (FNAFILE, "$filename");
  if ( !($firstline = <$fh>) ) {
    print "Can NOT open the file called: $filename \n";
    exit();
  }
  
  @lines = <$fh>;                   	# read all the remaining lines
  chomp @lines;                         # remove all the newlines at the end
  $DNAsequence = join( '', @lines);     # concatenate all the lines into 1 string
  
  # if we get to here, print SUCCESS and the first line of the FASTA file
  print "Successfully opened and read the file: \t $filename \n";
  print "$firstline \n\n";
  
  return $DNAsequence;
}
#-----------------------------------------------------------------------




# ---------------------- end of your Perl -----------------------------------

